'UNLZEXE 0.5
'ported to BlitzMax by K1n9_Duk3

SuperStrict

Const SUCCESS:Byte = 0
Const FAILURE:Byte = 1

Private

Const tmpfname$ = "$tmpfil$.exe"
Const backup_ext$ = ".olz"

Global ihead:Short[$10], ohead:Short[$10], inf:Short[8]
Global allocsize:Short
Global loadsize:Int

' EXE header test (is it LZEXE file?)
Function rdhead:Byte(ifile:TStream, ver:Int Var)
	For Local i:Int = 0 Until $10
		ihead[i] = ReadShort(ifile)
		ohead[i] = ihead[i]
	Next
	If (ihead[0]<>$5a4d Or ihead[4]<>2 Or ihead[$d]<>0)
		Return FAILURE
	EndIf
	If ihead[$c]=$1c And (ihead[$e]=$5A4C And ihead[$f]=$3930) '= "LZ09"
		ver = 90
		Return SUCCESS
	EndIf
	If ihead[$c]=$1c And (ihead[$e]=$5A4C And ihead[$f]=$3139) '= "LZ91"
		ver = 91
		Return SUCCESS
	EndIf
	Return FAILURE
EndFunction

' make relocation table
Function mkreltbl:Byte(ifile:TStream, ofile:TStream, ver:Int)
	Local i:Int, fpos:Long
	
	allocsize = ((ihead[1]+16-1) Shr 4) + ((ihead[2]-1) Shl 5) - ihead[4] + ihead[5]
	fpos = (ihead[$b]+ihead[4]) Shl 4
	If SeekStream(ifile, fpos) <> fpos	' goto CS:0000
		Return FAILURE
	EndIf
	For Local n:Int = 0 Until 8
		inf[n] = ReadShort(ifile)
	Next
	ohead[$a] = inf[0]	' IP
	ohead[$b] = inf[1]	' CS
	ohead[$8] = inf[2]	' SP
	ohead[$7] = inf[3]	' SS
	Rem
		/* inf[4]:size of compressed Load Module (PARAGRAPH)*/
		/* inf[5]:increase of Load Module size (PARAGRAPH)*/
		/* inf[6]:size of decompressor with  compressed relocation table (Byte) */
		/* inf[7]:check sum of decompresser with compressd relocation table(Ver.0.90) */	
	EndRem
	ohead[$c] = $1c
	If SeekStream(ofile, $1c) <> $1c
'		Print "seek error"
		Return FAILURE
	EndIf
	Select ver
	Case 90
		i = reloc90(ifile, ofile, fpos)
	Case 91
		i = reloc91(ifile, ofile, fpos)
	Default
		i = FAILURE
	EndSelect
	If i<>SUCCESS
'		Print "error at relocation table."
		Return FAILURE
	EndIf
	fpos = StreamPos(ofile)
	If fpos = -1
		Return FAILURE
	EndIf
	i = fpos & $1FF
	If i Then i = $200-i
	ohead[4] = (fpos+i) Shr 4
	
	While i > 0
		WriteByte(ofile, 0)
		i :- 1
	Wend
	Return SUCCESS
EndFunction

' for LZEXE ver 0.90
Function reloc90:Byte(ifile:TStream, ofile:TStream, fpos:Long)
	Local c:Int, rel_count:Short=0, rel_seg:Short, rel_off:Short
	
	If SeekStream(ifile, fpos+$19d) <> fpos+$19d
		Return FAILURE
	EndIf
	
	rel_seg = 0
	Repeat
		If Eof(ifile) Then Return FAILURE
		c = ReadShort(ifile)
		While c>0
			rel_off = ReadShort(ifile)
			WriteShort(ofile, rel_off)
			WriteShort(ofile, rel_seg)
			rel_count :+ 1
			c :- 1
		Wend
		rel_seg :+ $1000
	Until rel_seg = 0
	ohead[3]=rel_count
	Return SUCCESS
EndFunction

' for LZEXE ver 0.91
Function reloc91:Byte(ifile:TStream, ofile:TStream, fpos:Long)
	Local span:Short, rel_count:Short=0, rel_seg:Short, rel_off:Short
	
	If SeekStream(ifile, fpos+$158) <> fpos+$158
		Return FAILURE
	EndIf
	
	rel_off = 0
	rel_seg = 0
	Repeat
		If Eof(ifile) Then Return FAILURE
		span = ReadByte(ifile)
		If span = 0
			span = ReadShort(ifile)
			If span = 0
				rel_seg :+ $FFF
				Continue
			ElseIf span = 1
				Exit
			EndIf
		EndIf
		rel_off :+ span
		rel_seg :+ (rel_off & (-1 ~ $f)) Shr 4
		rel_off :& $f
		WriteShort(ofile, rel_off)
		WriteShort(ofile, rel_seg)
		rel_count :+ 1
	Forever
	ohead[3] = rel_count
	Return SUCCESS
EndFunction

Type TBitstream
	Field fp:TStream, buf:Short, count:Byte

	Method GetBit:Byte()
		Local b:Byte = buf & 1
		count :- 1
		If count = 0
			buf = ReadShort(fp)
			count = $10
		Else
			buf = buf Shr 1
		EndIf
		
		Return b
	EndMethod
EndType

Function initbits:TBitstream(filep:TStream)
	Local p:TBitstream = New TBitstream
	p.fp = filep
	p.Count = $10
	p.buf = ReadShort(filep)
	Return p
EndFunction

' decompressor routine
Function unpack:Byte(ifile:TStream, ofile:TStream)
	Local _len:Int, span:Int, fpos:Long
	Local bits:TBitstream
	Local data:Byte[$4500], p:Int=0
	
	fpos = (ihead[$b]-inf[4]+ihead[4]) Shl 4
	If SeekStream(ifile, fpos) <> fpos
		Return FAILURE
	EndIf
	fpos = ohead[4] Shl 4
	If SeekStream(ofile, fpos) <> fpos
		Return FAILURE
	EndIf
	bits = initbits(ifile)
'	WriteString(StandardIOStream, " unpacking. ")
'	StandardIOStream.Flush()
	
	Repeat
		If p>$4000
			For Local i:Int = 0 Until $2000
				WriteByte(ofile, data[i])
			Next
			p :- $2000
			For Local i:Int = 0 Until p
				data[i] = data[i+$2000]
			Next
'			WriteString(StandardIOStream, ".")
'			StandardIOStream.Flush()
		EndIf
		If bits.GetBit()
			data[p] = ReadByte(ifile)
			p :+ 1
			Continue
		EndIf
		If Not bits.GetBit()
			_len = bits.GetBit() Shl 1
			_len :| bits.GetBit()
			_len :+ 2
			span = ReadByte(ifile) | $FF00
		Else
			span = ReadByte(ifile)
			_len = ReadByte(ifile)
			span :| ((_len & (-1 ~ $07)) Shl 5) | $E000
			_len = (_len & $07)+2
			If _len = 2
				_len = ReadByte(ifile)
				
				If _len = 0
					Exit
				EndIf
				If _len = 1
					Continue
				Else
					_len :+ 1
				EndIf
			EndIf
		EndIf
		While _len > 0
			data[p] = data[Short(p+span)]
			p :+ 1
			_len :- 1
		Wend
	Forever
	If p<>0
		For Local i:Int = 0 Until p
			WriteByte(ofile, data[i])
		Next
	EndIf
	loadsize = StreamPos(ofile)-fpos
'	Print "end"
	Return SUCCESS
EndFunction

' write EXE header
Function wrhead(ofile:TStream)
	If ihead[6]<>0
		ohead[5] = allocsize-((loadsize+16-1) Shr 4)
		If ihead[6]<>$FFFF
			ohead[6] :- (ihead[5]-ohead[5])
		EndIf
	EndIf
	ohead[1]=(loadsize+(ohead[4] Shl 4)) & $1ff
	ohead[2]=(loadsize+(ohead[4] Shl 4)+$1ff) Shr 9
	SeekStream(ofile, 0)
	For Local i:Int = 0 Until $e
		WriteShort(ofile, ohead[i])
	Next
EndFunction

Public

Function UnLZEXE:Byte(infile:Object, outfile:Object)
	Local ifile:TStream, ofile:TStream
	Local ver:Int
	
	ifile = ReadFile(infile)
	If Not ifile
		Return FAILURE
	EndIf
	If rdhead(ifile, ver)<>SUCCESS
		Return FAILURE
	EndIf
'	ofile = CreateMemoryStream($FFFFF)
	ofile = WriteFile(outfile)
	If Not ofile
		CloseFile(ifile)
		Return FAILURE
	EndIf
'	WriteString(StandardIOStream, "file '"+infile+"' is compressed by LZEXE Ver. ")
'	Select ver
'	Case 90
'		Print "0.90"
'	Case 91
'		Print "0.91"
'	EndSelect
	If mkreltbl(ifile, ofile, ver) <> SUCCESS
		CloseFile(ifile)
		CloseFile(ofile)
'		DeleteFile(outfile)
		Return FAILURE
	EndIf
	If unpack(ifile, ofile) <> SUCCESS
		CloseFile(ifile)
		CloseFile(ofile)
'		DeleteFile(outfile)
		Return FAILURE
	EndIf
	CloseFile(ifile)
	wrhead(ofile)
'	Print "outfile is :"+StreamSize(ofile)
	CloseFile(ofile)
	Return SUCCESS
EndFunction
